#include "glwidget.h"
#include <iostream>
#include <QPixmap>
#include <QImage>
/**
@param format format ktory sa ma pouzit pri vytvarani OpenGL okna. pozri Qt dokumentaciu ku QGLWidget
@param parent Qt rodic
*/
GLwidget::GLwidget(const QGLFormat &format, QWidget *parent) : QGLWidget(format, parent)
{
}

GLwidget::~GLwidget()
{
    //dtor
}
/**
Inicializacia OpenGL
*/
void GLwidget::initializeGL()
{
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    std::cout << "Inicializujem OpenGL" << std::endl;
    glGenTextures(1, &tex);
    glBindTexture(GL_TEXTURE_2D, tex);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glEnable(GL_TEXTURE_2D);
    //updateGL();
}
/**
Vykreslovanie OpenGL sceny
*/
void GLwidget::paintGL()
{
    glClear(GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, tex);
    glBegin(GL_QUADS);
    //glColor3f(1.0f, 0.0f, 0.0f);
    glTexCoord2d(0.0f, 0.0f);glVertex3f(-1.0f, -1.0f, 0.0f);
    glTexCoord2d(1.0f, 0.0f);glVertex3f( 1.0f, -1.0f, 0.0f);
    glTexCoord2d(1.0f, 1.0f);glVertex3f( 1.0f,  1.0f, 0.0f);
    glTexCoord2d(0.0f, 1.0f);glVertex3f(-1.0f,  1.0f, 0.0f);
    glEnd();

}

void GLwidget::resizeGL(int w,int h)
{
    glViewport(0, 0, w, h);
}
/**
Nacita texturu do OpenGL do akktualneho widgetu
@param w sirka textury
@param h vyska textury
@param texture pixelove data textury
*/
void GLwidget::loadTexture(int w, int h, unsigned char *texture)
{
    glBindTexture(GL_TEXTURE_2D, tex);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, texture);
}
